#!/bin/sh
#
# iiim		Start and stop IIIMF server
#
# chkconfig: 2345 87 17
# description: iiimf server

# Source function library.
. /etc/init.d/functions

NAME=iiimd
IIIMD="/usr/bin/${NAME}"

LOCKER="/var/lock/subsys/iiimd"
OPTIONS=""
RETVAL=0

USER=iiimd
SOCKETDIR=/var/run/iiim/.iiimp-unix

test -x $IIIMD || exit 0

start() {
	if [ ! -f $LOCKER ]; then
		echo -n $"Starting IIIMF input server: "
		# make sure USER owns unix socket directory
		[ -d "${SOCKETDIR}" ] && chown ${USER}:${USER} -R ${SOCKETDIR}
		daemon --user $USER $IIIMD $OPTIONS 2>&1 </dev/null
		echo
		RETVAL=$?
		[ $RETVAL -eq 0 ] && touch $LOCKER
	else
		return 0
	fi
	return $RETVAL
}

stop() {
        echo -n $"Stopping IIIMF input server: "
	killproc ${NAME}
	echo
	RETVAL=$?
	[ $RETVAL -eq 0 ] && rm -f $LOCKER
}

case "$1" in
  start)
        start
        ;;
  stop)
        stop
        ;;
  status)
        status iiimd
        ;;
  restart|reload)
        stop
        start
        ;;
  condrestart)
        if [ -f $LOCKER ]; then
            stop
            start
        fi
        ;;
  *)
        echo $"Usage: $0 {start|stop|restart|condrestart|status}"
        exit 1
esac

exit $RETVAL
