%define version		12.2
%define svn_version	svn2613
%define release		1.%{svn_version}.2mdk
%define src_name		iiimf-src-im-sdk

%define libname_orig lib%{name}
%define libname %mklibname %{name} 0

%define iiim_dir		%{_libdir}/iiim
%define iiim_aclocal	%{iiim_dir}/acfiles
%define iiim_includedir	%{_includedir}/iiim
%define engine_dir		%{iiim_dir}/le

%define iiim_user		iiimd
%define iiim_service	iiim

%define sendhup		%{_bindir}/killall -HUP iiimd >& /dev/null || :
%define inst_engine	%{_bindir}/iiimf-le-tools -g --install %{engine_dir}/
%define uninst_engine	%{_bindir}/iiimf-le-tools -g --remove %{engine_dir}/

%define with_qt 1


Summary:	IIIMF multilingual Unicode input method framework
Name:		iiimf
Version:		%{version}
Release:		%{release}
License:		Distributable

# get the latest svn files:
# $ svn co http://svn.openi18n.org:8081/repos/im-sdk/trunk im-sdk
# then run ./make-dist
Source0:		%{src_name}-%{svn_version}.tar.bz2
Source2:		iiimd-init.d


# *** patches from fedora
# *** ---------->
# iiimf-gtkimmodule patches (300-)
Patch300:	im-sdk-iiimgcf-warning.patch.bz2
Patch302:	iiimgcf-event-status-done.patch.bz2

# IIIMQCF patches (500-)
Patch550:	iiimqcf-rh-build.patch.bz2

# iiimf-server patches (600-)
Patch600:	im-sdk-11.4-iiimsf-daemon.patch.bz2

# iiimf-xim (htt_xbe) patches (700-)
Patch700:	htt_xbe-fix-build-20040203.patch.bz2
Patch701:	htt_xbe-fix-crash-134035_140503.patch.bz2
Patch702:	htt_xbe-fix-x86_64.patch.bz2

# LEIF(Sun Simplified Chinese) patches (2500-)
Patch2500:	sun-chinese-le-libdir.patch.bz2
# *** <----------


URL:			http://www.openi18n.org/subgroups/im/IIIMF/
Group:		System/Internationalization
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:		tcp_wrappers
BuildRequires:		gettext-devel m17n-lib-devel

# for iiimf-gtkimmodule
BuildRequires:		gtk2-devel, libGConf2_4-devel

%if %with_qt
# for iiimf-qtimmodule
BuildRequires:		qt3-devel >= 3.3.4-9mdk
%endif

# for iiimf-gnome-im-switcher
BuildRequires:		gnome-panel-devel, libglade2.0_0-devel, libgnomeui2_0-devel
BuildRequires:		autoconf, automake, libtool, gettext, libxml2-devel

# for iiimf-engines-canna
BuildRequires:		canna-devel >= 3.7p1

%description
IIIMF is another multilingual Unicode input method framework,
which is a replacement of existing input method frameworks such as XIM.


# *** base packages
# *** ---------->
%package -n	%{libname}
Summary:	Internet/Intranet Input Method Framework libraries
Group:		System/Internationalization
Provides:		%{libname_orig} = %{version}-%{release}

%description -n %{libname}
Provides Internet/Intranet Input Method Client Framework library.

%package -n	%{libname}-devel
Summary:	Internet/Intranet Input Method development files
Group:		Development/C
Requires:		%{libname} = %{version}-%{release}
Provides:		%{name}-devel = %{version}-%{release}
Provides:		%{libname_orig}-devel = %{version}-%{release}

%description -n %{libname}-devel
This package contains development files for IIIMF.

%package	server
Summary:	IIIMF input method server
Group:		System/Internationalization
Requires:			%{libname} = %{version}-%{release}
Requires(pre):		/usr/sbin/useradd, /usr/sbin/usermod
Requires(post):	/sbin/chkconfig
Requires(preun):	/sbin/service, /sbin/chkconfig, /usr/sbin/userdel
Requires(postun):	/sbin/service

%description	server
IIIMF server is a server module of Internet/Intranet Input Method Framework.

%package	gtkimmodule
Summary:	GTK input method module for iiimf
Group:		System/Internationalization
Prereq:		%{_sbindir}/update-alternatives
Prereq:		%_bindir/gtk-query-immodules-2.0
Requires:		%{name}-server = %{version}

%description	gtkimmodule
Gtk Input Method Context for IIIM provides GUI to display input method 
status and to select input languages in your Gtk+ applicaitons.

%if %with_qt
%package	qtimmodule
Summary:	Qt Input Method module
Group:		System/Internationalization
Prereq:		%{_sbindir}/update-alternatives
Requires:		%{name}-server = %{version}
Requires:		libqt3 >= 3.3.4-101mdk

%description	qtimmodule
Qt Input Method module for iiimf.
%endif

%package	xim
Summary:	IIIMF XIM BackEnd module
Group:		System/Internationalization
Prereq:		%{_sbindir}/update-alternatives
Requires:		%{name}-server = %{version}

%description	xim
Provides XIM bridge modules through which legacy XIM clients should
be able to communicate to IIIMF server.

%package	gnome-im-switcher
Summary:	GNOME panel IM switcher and IM configuration tool
Group:		System/Internationalization
Prereq:		gtk2 >= 2.6.0
Requires:		%{name}-gtkimmodule = %{version}
Requires:		%{name}-xim = %{version}
Requires:		gnome-panel

%description	gnome-im-switcher
GNOME panel input method applet and gnome input method configuration tool.
# *** <----------


# *** primary language engines
# *** ---------->
%package	engines-canna
Summary:	Japanese Canna engine for iiimf-server
Group:		System/Internationalization
Requires:			%{name}-gtkimmodule = %{version}
Requires:			%{name}-xim = %{version}
Requires:			canna
Requires(post):	%{_bindir}/iiimf-le-tools, %{_bindir}/killall
Requires(preun):	%{_bindir}/iiimf-le-tools
Requires(postun):	%{_bindir}/killall

%description	engines-canna
Provides Japanese Canna engine for iiimf-server.

%package	engines-hangul
Summary:	Korean language engine for iiimf-server
Group:		System/Internationalization
Requires:			%{name}-gtkimmodule = %{version}
Requires:			%{name}-xim = %{version}
Requires(post):	%{_bindir}/iiimf-le-tools, %{_bindir}/killall
Requires(preun):	%{_bindir}/iiimf-le-tools
Requires(postun):	%{_bindir}/killall

%description	engines-hangul
Provides Korean language engine for iiimf-server

# (ut) iiimf-engines-unit is a collection of table based
# language engines. I think it should be covered by iiimf-m17n,
# but iiimf-m17n has been started recently, so still it's incomplete.
%package	engines-unit
Summary:	Unit language engines for iiimf-server
Group:		System/Internationalization
Requires:			%{name}-gtkimmodule = %{version}
Requires:			%{name}-xim = %{version}
Requires(post):	%{_bindir}/iiimf-le-tools, %{_bindir}/killall
Requires(preun):	%{_bindir}/iiimf-le-tools
Requires(postun):	%{_bindir}/killall

%description	engines-unit
Provides Unit language engines for iiimf-server.
# *** <----------


# *** additional language engines
# *** ---------->
%package	engines-m17n
Summary:	M17n-lib language engine for iiimf-server
Group:		System/Internationalization
Requires:			%{name}-gtkimmodule = %{version}
Requires:			%{name}-xim = %{version}
Requires(post):	%{_bindir}/iiimf-le-tools, %{_bindir}/killall
Requires(preun):	%{_bindir}/iiimf-le-tools
Requires(postun):	%{_bindir}/killall

%description	engines-m17n
Provides m17n-lib language engine for iiimf-server.

%package	engines-sun-chinese
Summary:	Chinese language engines from Sun for iiimf-server
Group:		System/Internationalization
Requires:			%{name}-gtkimmodule = %{version}
Requires:			%{name}-xim = %{version}
Requires(post):	%{_bindir}/iiimf-le-tools, %{_bindir}/killall
Requires(preun):	%{_bindir}/iiimf-le-tools
Requires(postun):	%{_bindir}/killall

%description	engines-sun-chinese
Provides Chinese language engines from Sun for iiimf-server.
This package includes two engines.
They are for traditional Chinese and simplified Chinese.

%package	engines-sun-thai
Summary:	Thai language engine from Sun for iiimf-server
Group:		System/Internationalization
Requires:			%{name}-gtkimmodule = %{version}
Requires:			%{name}-xim = %{version}
Requires(post):	%{_bindir}/iiimf-le-tools, %{_bindir}/killall
Requires(preun):	%{_bindir}/iiimf-le-tools
Requires(postun):	%{_bindir}/killall

%description	engines-sun-thai
Thai language engine from Sun for iiimf-server.
# *** <----------


%prep
%setup -q -n iiimf-im-sdk-%{svn_version}
%patch300 -p1 -b .300-warnings
%patch302 -p1 -b .302-status_end
%patch550 -p1 -b .550-build
%patch600 -p1 -b .600-rh-daemon
%patch700 -p1 -b .700-build-20040203
%patch701 -p1 -b .701-fix-crash
%patch702 -p1 -b .702-fix-x86_64
%patch2500 -p0 -b .2500-libdir


# *** choose primary language engines
%define le_base default canna hangul unit

# *** choose additional language engines
%define le_extras leif/m17n_le leif/sch_le_sun leif/tch_le_sun leif/thai_le_sun

# define gnome-im-switcher. It is called GIMLET.
%define gimlet iiimf-im-switcher

# *** set directories of the base softwares.
# lib includes libiiimf.
# iiimsf includes iiimf-server.
# iiimxcf includes iiimf-xim.
# leif includes primary language engines.
# %{le_extras} includes additional language engines.
# iiimgcf includes iiimf-gtkimmodule.
# gnome-im-switcher includes iiimf-gnome-im-switcher.
%define builddirs lib/CSConv lib/EIMIL lib/iiimp lib/iiimcf iiimsf iiimxcf/xiiimp.so iiimxcf/htt_xbe leif %{le_extras} iiimgcf gnome-im-switcher


# generate config files
make bootstrap CONFIGDIRS="%{builddirs}"


%build
export CFLAGS="-Wall $RPM_OPT_FLAGS"
export CXXFLAGS="-Wall $RPM_OPT_FLAGS"

# run configure
for dir in %{builddirs}; do
	( cd $dir
	  %configure --with-imdir=%{iiim_dir} --with-status-default-under-app
        )
done

# build the base softwares and the language engines
make compile BUILDDIRS="%{builddirs}" LE_TARGETS="%{le_base}" SRCNAME="%{src_name}"


%if %with_qt
# build iiimf-qtimmodule
# *** ---------->
cd iiimqcf/src

# *** make sure the directories are set correctly
unset QTDIR && . /etc/profile.d/qtdir3.sh
%global qt_im_dir %{_libdir}/qt3/plugins/inputmethods

IIIMQCF_PKG_CFLAGS=`/usr/bin/pkg-config --cflags qt-mt glib-2.0` IIIMQCF_PKG_LDADD=`/usr/bin/pkg-config --libs qt-mt glib-2.0` qmake
# fix the crap Makefile generated by qmake
mv Makefile Makefile.in
sed -e 's/-I-I/-I/g' -e 's/-I-D/-D/g' Makefile.in > Makefile
make
cd -
# *** <----------
%endif


%install
rm -rf ${RPM_BUILD_ROOT}

export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
make DESTDIR=$RPM_BUILD_ROOT install BUILDDIRS="%{builddirs}" LE_TARGETS="%{le_base}"
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/
cp %{SOURCE2} $RPM_BUILD_ROOT%{_initrddir}/%{iiim_service}

# remove unnecessary devel files
rm -f $RPM_BUILD_ROOT%{iiim_dir}/xiiimp.{a,la}
rm -f $RPM_BUILD_ROOT%{_libdir}/gtk-2.0/*/immodules/im-iiim.{a,la}

%if %with_qt
# install iiimf-qtimmodule
cd iiimqcf/src
install -d $RPM_BUILD_ROOT%{qt_im_dir}
install libiiimqcf.so $RPM_BUILD_ROOT%{qt_im_dir}
cd -
%endif

# install xml config files
install -d $RPM_BUILD_ROOT%{_sysconfdir}/iiim
touch $RPM_BUILD_ROOT%{_sysconfdir}/iiim/le.xml.conf

# make sure dl modules are executable
chmod a+x $RPM_BUILD_ROOT%{engine_dir}/*/*.so

# remove unnecessary files
rm -f $RPM_BUILD_ROOT%{_bindir}/*test

# include required include and acfiles files
mkdir -p $RPM_BUILD_ROOT%{iiim_includedir}
	cp include/{IM*,syscfg,threaddef}.h $RPM_BUILD_ROOT%{iiim_includedir}
	cp -r include/{X11,iml} $RPM_BUILD_ROOT%{iiim_includedir}
mkdir -p $RPM_BUILD_ROOT%{iiim_aclocal}
	cp acfiles/{check_{gtk,socket,sys,x,xml},im_common}.m4 $RPM_BUILD_ROOT%{iiim_aclocal}


# *** post scripts for base packages
# *** ---------->
%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%pre server
if ! /usr/sbin/usermod -d %{iiim_dir} %{iiim_user} >/dev/null 2>&1; then
  /usr/sbin/useradd %{iiim_user} -c "IIIMF server" -r -s /sbin/nologin -d %{iiim_dir} -M >/dev/null 2>&1
fi

# migrate old config file
if [ ! -f "%{_sysconfdir}/iiim/iiimd.xml.conf" -a -f "%{_sysconfdir}/iiim/htt.xml.conf" ]; then
  mv %{_sysconfdir}/iiim/{htt,iiimd}.xml.conf
fi
exit 0

%post server
# make sure we own any old unix domain socket
[ -d %{_localstatedir}/run/iiim/.iiimp-unix ] && chown %{iiim_user}:%{iiim_user} -R %{_localstatedir}/run/iiim/.iiimp-unix

/sbin/chkconfig --add iiim
%{inst_engine}default/default.so --default --lang en >& /dev/null || :
if /usr/sbin/usermod -d %{iiim_dir} htt >/dev/null 2>&1; then
  /usr/sbin/userdel htt 2>/dev/null 2>&1
fi

%preun server
if [ "$1" = 0 ] ; then
   %{uninst_engine}default/default.so >& /dev/null || :
  /sbin/service %{iiim_service} stop >/dev/null 2>&1
  /sbin/chkconfig --del %{iiim_service}
  /usr/sbin/userdel %{iiim_user} 2>/dev/null 2>&1
fi

%postun server
if [ "$1" -ge "1" ]; then
  /sbin/service %{iiim_service} condrestart >/dev/null 2>&1
fi

%post gtkimmodule
%{_bindir}/gtk-query-immodules-2.0 > %{_sysconfdir}/gtk-2.0/gtk.immodules.%_lib

%postun gtkimmodule
%{_bindir}/gtk-query-immodules-2.0 > %{_sysconfdir}/gtk-2.0/gtk.immodules.%_lib

%post gnome-im-switcher
GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source` gconftool-2  --makefile-install-rule /etc/gconf/schemas/gnome-im-switcher.schemas > /dev/null
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  gtk-update-icon-cache %{_datadir}/icons/hicolor
fi

%postun gnome-im-switcher
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  gtk-update-icon-cache %{_datadir}/icons/hicolor
fi
# *** <----------


# *** post scripts for primary language engines
# *** ---------->
%post engines-canna
%{inst_engine}CannaLE/CannaLE.so --default >& /dev/null || :
%{sendhup}

%preun engines-canna
if [ "$1" = 0 ]; then
  %{uninst_engine}CannaLE/CannaLE.so >& /dev/null || :
fi

%postun engines-canna
if [ "$1" = 0 ]; then
  %{sendhup}
fi

%post engines-hangul
%{inst_engine}hangul/hangul.so --default >& /dev/null || :
%{sendhup}

%preun engines-hangul
if [ "$1" = 0 ]; then
  %{uninst_engine}hangul/hangul.so >& /dev/null || :
fi

%postun engines-hangul
if [ "$1" = 0 ]; then
  %{sendhup}
fi

%post engines-unit
%{inst_engine}unitle/unitle.so >& /dev/null || :
%{sendhup}

%preun engines-unit
if [ "$1" = 0 ]; then
  %{uninst_engine}unitle/unitle.so >& /dev/null || :
fi

%postun engines-unit
if [ "$1" = 0 ]; then
  %{sendhup}
fi
# *** <----------


# *** post scripts for additional language engines
# *** ---------->
%post engines-m17n
%{inst_engine}m17nle/m17nle.so >& /dev/null || :
%{sendhup}

%preun engines-m17n
if [ "$1" = 0 ]; then
  %{uninst_engine}m17nle/m17nle.so >& /dev/null || :
fi

%postun engines-m17n
if [ "$1" = 0 ]; then
  %{sendhup}
fi

%post engines-sun-chinese
%{inst_engine}cle/cle.so >& /dev/null || :
%{inst_engine}twle/twle.so >& /dev/null || :
%{sendhup}

%preun engines-sun-chinese
if [ "$1" = 0 ]; then
  %{uninst_engine}cle/cle.so >& /dev/null || :
  %{uninst_engine}twle/twle.so >& /dev/null || :
fi

%postun engines-sun-chinese
if [ "$1" = 0 ]; then
  %{sendhup}
fi

%post engines-sun-thai
%{inst_engine}thaile/thaile.so >& /dev/null || :
%{sendhup}

%preun engines-sun-thai
if [ "$1" = 0 ]; then
  %{uninst_engine}thaile/thaile.so >& /dev/null || :
fi

%postun engines-sun-thai
if [ "$1" = 0 ]; then
  %{sendhup}
fi
# *** <----------


%clean
rm -rf ${RPM_BUILD_ROOT}


# *** base packages
# *** ---------->
%files -n %{libname}
%defattr (-, root, root,-)
%dir %{iiim_dir}
%{_libdir}/libiiimcf.so.*
%{_libdir}/libiiimp.so.*
%{_libdir}/libiiimutils.so.*
%{iiim_dir}/csconv

%files -n %{libname}-devel
%defattr (-, root, root,-)
%dir %{iiim_dir}
%{iiim_includedir}
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/pkgconfig
%{iiim_aclocal}

%files server
%defattr (-, %{iiim_user}, %{iiim_user})
%dir %{_localstatedir}/run/iiim
%dir %{_localstatedir}/log/iiim
%defattr (-, root, root,-)
%dir %{_sysconfdir}/iiim
%dir %{_libexecdir}
%{_initrddir}/*
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/iiim/iiimd.xml.conf
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sysconfdir}/iiim/le.xml.conf
%{_bindir}/iiimd
%{iiim_dir}/iiimd-watchdog
%{_bindir}/iiimf-le-tools
%{_libexecdir}/iiimf-segv-logger
%dir %{engine_dir}
%{engine_dir}/default*
%dir %{_datadir}/iiim
%{_datadir}/iiim/gdbcmd

%files gtkimmodule
%defattr (-, root, root,-)
%{_libdir}/gtk-2.0/*/immodules/im-iiim.so

%if %with_qt
%files qtimmodule
%defattr (-, root, root,-)
%{qt_im_dir}
%endif

%files xim
%defattr (-, root, root,-)
%dir %{iiim_dir}
%{_bindir}/iiimx
%{iiim_dir}/iiim-xbe
%{iiim_dir}/xiiimp.so*

%files gnome-im-switcher
%defattr (-, root, root,-)
%doc gnome-im-switcher/{AUTHORS,COPYING,ChangeLog,README}
%{_sysconfdir}/gconf/schemas
%{_libdir}/bonobo
%dir %{_libexecdir}
%{_libexecdir}/gnome-im-switcher-applet
%{_datadir}/locale
%{_datadir}/gnome-2.0
%{_datadir}/%{gimlet}
%{_datadir}/gnome/help/imswitcher
%{_datadir}/omf/%{gimlet}
%{_bindir}/gnome-im*
%{_datadir}/control-center-2.0
%{_datadir}/icons/hicolor
%{_datadir}/pixmaps
# *** <----------


# *** primary language engines
# *** ---------->
%files engines-canna
%defattr (-, root, root,-)
%dir %{iiim_dir}
%dir %{engine_dir}
%{engine_dir}/CannaLE

%files engines-hangul
%defattr (-, root, root,-)
%dir %{iiim_dir}
%dir %{engine_dir}
%{engine_dir}/hangul

%files engines-unit
%defattr (-, root, root,-)
%dir %{iiim_dir}
%dir %{engine_dir}
%{engine_dir}/unitle
# *** <----------


# *** additional language engines
# *** ---------->
%files engines-m17n
%defattr (-, root, root,-)
%dir %{iiim_dir}
%dir %{engine_dir}
%{engine_dir}/m17nle

%files engines-sun-chinese
%defattr (-, root, root,-)
%dir %{iiim_dir}
%dir %{engine_dir}
%{engine_dir}/cle
%{engine_dir}/twle

%files engines-sun-thai
%defattr (-, root, root,-)
%dir %{iiim_dir}
%dir %{engine_dir}
%{engine_dir}/thaile
# *** <----------


%changelog
* Tue May 10 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 12.2-1.svn2613.2mdk
- rebuild against qtimm aware qt

* Mon May 09 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 12.2-1.svn2613.1mdk
- enable to build without qt
- UTUMI Hirosi <utuhiro78@yahoo.co.jp>:
  o latest snapshot
  o add iiimf-qtimmodule

* Sat Apr 23 2005 UTUMI Hirosi <utuhiro78@yahoo.co.jp> - 12.1.1-1.svn2578.1mdk
- first spec for Mandriva Linux
